/*

IUAV IxD Lab 2, Venezia Jan-Apr 2010

students:
Giuseppe Burdo, Alessandro Filippi
teachers:
Gillian Crampton Smith, Philip Tabor


Project: Equilibria



technical references:
 
 http://wiki.webdearde.com/index.php?title=Tutorial:_Comenzando_con_Arduino
 http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1265097594
 http://www.arduino.cc/playground/Code/Stopwatch

PROGRAM FOR ARDUINO MEGA



*/

// leds on the platform

#include "WProgram.h"
void setup();
void loop();
void resetto();
void errore();
int leds[] = { 
  46, 47, 48, 49, 50, 51, 52, 53, 43};       //led Pins, which are under the bricks

// buttons on the right platform

int buttons[] = {
  30, 31, 32, 33, 34, 35, 36, 37, 38, 29};


int errori[] = {
  22,23};

int colonna = 13;

int outputPin = 5;

int gobboLeds[] = {
  11,12};
// variables used for the standby mode, in order to light on the leds on the platform with the interval specified

int num_leds = 9;        // number of the light under the bricks onto the platform
unsigned long timer = 400;     // time leds ON
int interval = 0;          // to define the amount of time before the next light led loop
unsigned long previousMillis = 0;


int buttonState = 0;

int mode = 1;

int luce = 0;

int luce_prev = 7;

boolean percorso = false;
boolean resetto_check = false;

int stepCase = 0;

int stepTime = 4000;    // keep the brick light on
int stepWarming = 1000;    //blink the brick, to advice that the time is finishing
int stepError = 100;    // blink fast to let the user know is wrong

boolean stepState = false;

int blink_counter = 0;

int stepActive = 0;

int stepNew = 2000;

int score= 0;

unsigned long resetTime = 60000;

unsigned long runTime = 0;

int columnLight;

int outputTime = 7000;

int errorLimit = 50;

int provNumber = 10; // total number of proverbs

int errorUnit =  1; // added errorValue per cyle

 #include <Servo.h>      // include the servo library

 Servo servoMotor;       // creates an instance of the servo object to control a servo
     


// ------------------------------ DEBUG MODE CONTROL

boolean debug = true;

unsigned long time;
int buttonError1;
int buttonError2;
int stepCheck;




void setup()                  
{
  Serial.begin(9600);
  
  //standby loop..for every "tot" seconds there is a flow of light on the platform,
  for (int i = 0; i < num_leds; i++){   // which let the user knows that there is something there..waiting for his action
    pinMode(leds[i], OUTPUT);
  }

  for (int i = 0; i < 10; i++){   // which let the user knows that there is something there..waiting for his action
    pinMode(buttons[i], INPUT);
  }

  for (int i = 0; i < 2; i++){   // which let the user knows that there is something there..waiting for his action
    pinMode(errori[i], INPUT);
  }
  pinMode (colonna, OUTPUT);

  servoMotor.attach(10);  // attaches the servo on pin 2 to the servo object
  
  for (int i = 0; i < 2; i++){   // which let the user knows that there is something there..waiting for his action
    pinMode(gobboLeds[i], OUTPUT);
  }
  
  pinMode(outputPin,OUTPUT);

}






void loop()
{ 

  if (debug == true) {
    Serial.print("Millis: ");
    Serial.print(millis());
    Serial.print(". Health: ");
    Serial.print(100-score);
    Serial.print(". Interval: ");
    Serial.println(interval);
  }

  switch(mode) {
  case 1:    // STANDBY MODE
    digitalWrite(colonna, LOW);
    resetto();
    time = millis();

    if (time - previousMillis > interval) {    //for every interval timing, restart the light loop for the leds on the floor
      previousMillis = millis();

      digitalWrite(leds[luce], HIGH);
      digitalWrite(leds[luce_prev], LOW);
      if (luce == 8) {
        interval = 5000;
      } 
      else {
        interval = 400;
      }

      luce++;
      luce_prev = luce - 1;   
      if(luce > num_leds-1) {
        luce = 0;
        luce_prev = 8;
      }
    }

    if (digitalRead(buttons[0]) == HIGH && digitalRead(buttons[9]) == HIGH) {
      resetto_check = true;
      mode = 2;
    }  

    break;
  case 2:    // EQUILIBRIA PATH GAME
    resetto();

    time = millis();

    if (time - previousMillis > interval) {    //for every interval timing, restart the light loop for the leds on the floor
      previousMillis = millis();

      if (stepState == false) {
        digitalWrite(leds[stepActive], HIGH);
        stepState = true;
      } 
      else {
        digitalWrite(leds[stepActive], LOW);
        stepState = false;
      }

      if (stepCase == 1) {
        blink_counter++;
        if (blink_counter>8) {
          stepCase = 2;
        }
      }
      if (stepCase == 2) {
        interval = stepError;
        errore();
      }     
      if (stepCase == 1) {
        interval = stepWarming;
      }
      if (stepCase == 0) {
        interval = stepTime;
        stepCase = 1;
      }
    }  // timer close 



    buttonState = digitalRead(buttons[8]);    // Last step ends the game and switch the system to RESULT OUTPUT (state 3) >> TESTED WORKS

    if (buttonState == HIGH && stepActive == 8) {
      resetto_check = true;
      mode = 3;          
    }



    timer = millis() - runTime; // reset time counts a time limit to perform a step before standby mode switch >> TESTED WORKS
    if (timer > resetTime) {
      runTime = millis();
      resetto_check = true;
      mode = 1;
    }

    if (digitalRead(buttons[0]) == HIGH && digitalRead(buttons[9]) == HIGH && stepActive > 0) { // reset game to add path presence >> TESTED WORKS
      resetto_check = true;
    }

    buttonError1 = digitalRead(errori[0]);
    buttonError2 = digitalRead(errori[1]);

    if (buttonError1 == HIGH || buttonError2 == HIGH) {      // Error detection, lateral platforms >> TESTED WORKS                                                                          

      errore();
    }

    stepCheck = stepActive-1;
    if (stepCheck < 0) {
      stepCheck = 0;
    } 

    for(int i=0; i<8; i++){
      if ((stepActive != i && stepActive-1 != i && stepActive+1 != i) &&  digitalRead(buttons[i]) == HIGH) { // Error detection, wrong step TESTED WORK
        errore(); 
      }
    }

    buttonState = digitalRead(buttons[stepActive+1]);

    if (buttonState == HIGH) {
      digitalWrite(leds[stepActive], LOW);
      stepState = false;
      stepActive++;
      stepCase = 0;
      blink_counter = 0;
      interval = stepNew;    //it doesn't work always...so it works just if delay is added
      previousMillis = millis();

      runTime = millis();
    }

    columnLight = 100-score;
    if (columnLight < 0) {
      columnLight = 0;
    } 

    if (score > 100) {
      score = 100;
      // servoMotor.write(columnLight);
      //  delay(15);    
    }

    digitalWrite(colonna, HIGH);
    servoMotor.write(map(columnLight,0,100,0,73));
    delay(15);

    /* COLUMN OUTPUT
     
     On case 2 the main light projector on the column should be activated at start, and remain active in case 3. Should be deactivated 
     only when the system switch to case 1;
     Here the code should move the actuator filter on the column light. Starting from a full health of 100 (fully open), to a minimum of
     0 (fully close);
     
     */
    break;
  case 3:    // RESULT OUTPUT
    digitalWrite(colonna, HIGH);
    
    delay(2000);
    
    if ((100-score) >= errorLimit) { // Serial output activation signal
      digitalWrite(gobboLeds[1],HIGH);
      digitalWrite(outputPin,HIGH);
    }    
    
    if ((100-score) < errorLimit) {
      digitalWrite(gobboLeds[0],HIGH);
    }
    
    delay(6000);
    digitalWrite(outputPin,LOW);
    digitalWrite(gobboLeds[0],LOW);
    digitalWrite(gobboLeds[1],LOW);
    
    interval = 0;
    resetto();
    mode = 1; // switch to STANDBY MODE

    break;
  }
}

void resetto() {
  if (resetto_check == true) {
    for (int i = 0; i < num_leds; i++)  //for all the leds in the array
    {
      digitalWrite(leds[i], LOW); 
    }
    luce = 0;
    luce_prev = 8;
    interval = stepNew;
    resetto_check = false;
    stepCase = 0;
    stepState = false;
    stepActive = 0;
    runTime = millis();
    score = 0;
    blink_counter = 0;
    digitalWrite(colonna, LOW);
    servoMotor.write(0);
    delay(15);
  }
}

void errore() {
  score = score + errorUnit;

}

























int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

